#ifndef PSQLSERVER_H
#define PSQLSERVER_H

#include <kmysql/isqlserver.h>
#include <qstring.h>
#include <libpq-fe.h>

class PsqlServer : public ISqlServer
  {
  public:
  	PsqlServer(void);
    virtual ~PsqlServer(void);
    QueryResult connect(QString, QString, QString, int);
    void close(void);
    QueryResult selectBase(QString);
    QueryResult getBases(void);
    QueryResult getTables(QString, QString = 0);
    QueryResult getColumns(QString, QString);
    QueryResult query(QString);
    QueryResult createBase(QString);
    QueryResult dropBase(QString);
    QueryResult reload(void);
    QueryResult shutdown(void);
    QString serverInfo(void);
    bool isConnected(void) { return connected; }
    IObject *queryInterface(UIID);
  private:
  	void putTuples(QueryResult &, PGresult *);
  private:
    bool connected;
   PGconn *conn;
   QString pg_host;
   QString pg_user;
   QString pg_passwd;
   QString openedDB;
   int pg_port;
  };


#endif
